/* Generated by ts-generator ver. 0.0.8 */
/* tslint:disable */

import { Contract, ContractTransaction, EventFilter, Signer } from "ethers";
import { Listener, Provider } from "ethers/providers";
import { Arrayish, BigNumber, BigNumberish, Interface } from "ethers/utils";
import {
  TransactionOverrides,
  TypedEventDescription,
  TypedFunctionDescription
} from ".";

interface CapTableRegistryInterface extends Interface {
  functions: {
    add: TypedFunctionDescription<{ encode([adr]: [string]): string }>;

    list: TypedFunctionDescription<{ encode([]: []): string }>;

    remove: TypedFunctionDescription<{ encode([adr]: [string]): string }>;

    controllers: TypedFunctionDescription<{ encode([]: []): string }>;

    isController: TypedFunctionDescription<{ encode([adr]: [string]): string }>;

    listActive: TypedFunctionDescription<{ encode([]: []): string }>;

    setControllers: TypedFunctionDescription<{
      encode([operators]: [string[]]): string;
    }>;
  };

  events: {
    capTableAdded: TypedEventDescription<{
      encodeTopics([capTableAddress]: [string | null]): string[];
    }>;

    capTableRemoved: TypedEventDescription<{
      encodeTopics([capTableRemoved]: [string | null]): string[];
    }>;
  };
}

export class CapTableRegistry extends Contract {
  connect(signerOrProvider: Signer | Provider | string): CapTableRegistry;
  attach(addressOrName: string): CapTableRegistry;
  deployed(): Promise<CapTableRegistry>;

  on(event: EventFilter | string, listener: Listener): CapTableRegistry;
  once(event: EventFilter | string, listener: Listener): CapTableRegistry;
  addListener(
    eventName: EventFilter | string,
    listener: Listener
  ): CapTableRegistry;
  removeAllListeners(eventName: EventFilter | string): CapTableRegistry;
  removeListener(eventName: any, listener: Listener): CapTableRegistry;

  interface: CapTableRegistryInterface;

  functions: {
    add(
      adr: string,
      overrides?: TransactionOverrides
    ): Promise<ContractTransaction>;

    list(): Promise<string[]>;

    remove(
      adr: string,
      overrides?: TransactionOverrides
    ): Promise<ContractTransaction>;

    controllers(): Promise<string[]>;

    isController(adr: string): Promise<boolean>;

    listActive(): Promise<string[]>;

    setControllers(
      operators: string[],
      overrides?: TransactionOverrides
    ): Promise<ContractTransaction>;
  };

  add(
    adr: string,
    overrides?: TransactionOverrides
  ): Promise<ContractTransaction>;

  list(): Promise<string[]>;

  remove(
    adr: string,
    overrides?: TransactionOverrides
  ): Promise<ContractTransaction>;

  controllers(): Promise<string[]>;

  isController(adr: string): Promise<boolean>;

  listActive(): Promise<string[]>;

  setControllers(
    operators: string[],
    overrides?: TransactionOverrides
  ): Promise<ContractTransaction>;

  filters: {
    capTableAdded(capTableAddress: string | null): EventFilter;

    capTableRemoved(capTableRemoved: string | null): EventFilter;
  };

  estimate: {
    add(adr: string): Promise<BigNumber>;

    list(): Promise<BigNumber>;

    remove(adr: string): Promise<BigNumber>;

    controllers(): Promise<BigNumber>;

    isController(adr: string): Promise<BigNumber>;

    listActive(): Promise<BigNumber>;

    setControllers(operators: string[]): Promise<BigNumber>;
  };
}
